/************************************************************************
 *									*
 *		nr^Q@IC[UT|[gVXe		*
 *			ob|mds^Q				*
 *									*
 *				: wlncdlM		*
 *		t@C	: xmodem.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include "pcnet.h"
#include <string.h>

#define	ST_END		0
#define	ST_ERR		-1
#define	ST_ABORT	-2
#define	ST_1		1
#define	ST_2		2
#define	ST_3		3
#define	SOH		(CHAR)0x01
#define	EOT		(CHAR)0x04
#define	ACK		(CHAR)0x06
#define	NAK		(CHAR)0x15
#define	CAN		(CHAR)0x18
#define	TIMEOUT		0x101
#define	ABORT		0x102

typedef	struct	{
	USHORT	chNo;
	FILE	*fp;
	VOID	(*func)(USHORT, USHORT);
	USHORT	blkno;
	CHAR	rcv_buf[132];
	SHORT	timer;
	SHORT	retry_counter;
	SHORT	rcv_counter;
	LONG	save_fp;
	BOOL	crcMode;
} XMODEM;

/*--------------------------------------*/
/*		֐		*/
/*--------------------------------------*/
static	SHORT	s_start(XMODEM *);
static	SHORT	s_st1(XMODEM *, SHORT);
static	SHORT	s_st2(XMODEM *, SHORT);
static	SHORT	s_st3(XMODEM *, SHORT);
static	SHORT	send_dat(XMODEM *);
static	SHORT	r_start(XMODEM *);
static	SHORT	r_st1(XMODEM *, SHORT);
static	SHORT	r_st2(XMODEM *, SHORT);
static	SHORT	rcv_dat(XMODEM *);
static	SHORT	event(XMODEM *);
static	VOID	SendChar(XMODEM *, CHAR);
static	VOID	SendBlock(XMODEM *, CHAR *, USHORT);
static	VOID	SetTimer(XMODEM *, SHORT);
static	USHORT	calcrc(CHAR *, SHORT);

/*--------------------------------------*/
/*		ϐ		*/
/*--------------------------------------*/
static	BOOL	xFlag[N_CHANNEL];

/*=======================================================================
 |
 |		t@CM
 |
 |	SHORT	SXmodem(chNo, fp, func)
 |
 |		USHORT	chNo;		`lԍ
 |		FILE	*fp;		t@C|C^
 |		VOID	(*func)();	ubNԍ\֐
 |
 |		Ԓl			@OFI
 |					|PFMs
 |					|QF~
 |
 =======================================================================*/
SHORT	SXmodem(USHORT chNo, FILE *fp, VOID (*func)())
{
	SHORT	st, ev;
	DCBINFO		svDCBInfo, DCBInfo;
	XMODEM	xmodem;

	if (chNo == CH0)
		return(-1);

	xFlag[chNo] = TRUE;

	DosDevIOCtl(&DCBInfo, 0L, ASYNC_GETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);
	memcpy(&svDCBInfo, &DCBInfo, sizeof(DCBINFO));

	DCBInfo.fbFlowReplace = 0;
	DCBInfo.fbTimeout = MODE_READ_TIMEOUT;
	DosDevIOCtl(0L, &DCBInfo, ASYNC_SETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);

	ClearRcvQue(chNo);		/* Mobt@NA */

	xmodem.chNo = chNo;
	xmodem.fp = fp;
	xmodem.func = func;

	st = s_start(&xmodem);		/* MJn */
	while (st > 0) {
		ev = event(&xmodem);	/* Cxg҂ */
		switch (st) {
		case ST_1:
			st = s_st1(&xmodem, ev);
			break;
		case ST_2:
			st = s_st2(&xmodem, ev);
			break;
		case ST_3:
			st = s_st3(&xmodem, ev);
			break;
		}
	}

	DosDevIOCtl(0L, &svDCBInfo, ASYNC_SETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);

	xFlag[chNo] = FALSE;

	return(st);
}

/*=======================================================================
 |
 |		t@CMJn
 |
 |	SHORT	s_start(xp)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |
 |		Ԓl			rsQP
 |
 =======================================================================*/
static	SHORT	s_start(XMODEM *xp)
{
	SetTimer(xp, 60);		/* m`j҂^C}[Zbg */
	xp->blkno = 0;			/* ubNԍNA */

	return(ST_1);
}

/*=======================================================================
 |
 |		m`jiMvj҂
 |
 |	SHORT	s_st1(xp, ev)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	SHORT	s_st1(XMODEM *xp, SHORT ev)
{
	SHORT	st;

	st = ST_1;
	switch (ev) {
	case NAK:
		xp->crcMode = FALSE;
		goto label_1;
	case 'C':
		xp->crcMode = TRUE;
	label_1:
		xp->blkno++;		/* ubNԍXV */
		if (send_dat(xp) != EOF) {	/* f[^ubNM */
			SetTimer(xp, 60);	/* `bj҂^C}[Zbg */
			st = ST_2;
		} else {
			/* MI */
			SendChar(xp, EOT);	/* dnsM */
			st = ST_3;
		}
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM`bj҂
 |
 |	SHORT	s_st2(xp, ev)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	SHORT	s_st2(XMODEM *xp, SHORT ev)
{
	SHORT	st;

	st = ST_2;
	switch(ev) {
	case ACK:
		xp->blkno++;		/* ubNԍXV */
		if (send_dat(xp) != EOF) {	/* f[^ubNM */
			SetTimer(xp, 60);	/* `bj҂^C}[Zbg */
			st = ST_2;
		} else {
			/* MI */
			SendChar(xp, EOT);	/* dnsM */
			st = ST_3;
		}
		break;
	case NAK:
		/* t@Cʒu߂ */
		fseek(xp->fp, xp->save_fp, SEEK_SET);
		send_dat(xp);			/* f[^ubNM */
		SetTimer(xp, 60);		/* `bj҂^C}[Zbg */
		st = ST_2;
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		dnsM`bj҂
 |
 |	SHORT	s_st3(xp, ev)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	SHORT	s_st3(XMODEM *xp, SHORT ev)
{
	SHORT	st;

	st = ST_3;
	switch (ev) {
	case ACK:
		st = ST_END;
		break;
	case NAK:
		SendChar(xp, EOT);
		SetTimer(xp, 60);		/* `bj҂^C}[Zbg */
		break;
	case CAN:
		st = ST_ERR;
		break;
	case TIMEOUT:
		st = ST_ERR;
		break;
	case ABORT:
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM
 |
 |	SHORT	send_dat(xp)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |
 |		Ԓl			OFM
 |					dneFMI
 |
 =======================================================================*/
static	SHORT	send_dat(XMODEM *xp)
{
	SHORT	c, i;
	CHAR	sum;
	USHORT	crc;
	CHAR	sendBuf[132];

	/* t@C|C^Z[u */
	xp->save_fp = ftell(xp->fp);

	/* t@CI`FbN */
	if ((c = fgetc(xp->fp)) == EOF)
		return(EOF);

	sendBuf[0] = SOH;
	sendBuf[1] = (CHAR)xp->blkno;	/* ubNԍM */
	sendBuf[2] = (CHAR)~xp->blkno;	/* ]ubNԍM */
	sendBuf[3] = (CHAR)c;		/* f[^̂PoCgڑM */
	for (i = 4; i < 131; i++) {
		c = fgetc(xp->fp);		/* f[^ǂݍ */
		if (c == EOF)
			c = 0x1a;
		sendBuf[i] = (CHAR)c;	/* f[^M */
	}

	if (xp->crcMode) {
		crc = calcrc(&sendBuf[3], 128);
		sendBuf[i++] = (CHAR)(crc >> 8);
		sendBuf[i] = (CHAR)crc;
		SendBlock(xp, sendBuf, 133);
	} else {
		sum = 0;
		for (i = 3; i < 131; i++)
			sum += sendBuf[i];
		sendBuf[i] = sum;
		SendBlock(xp, sendBuf, 132);
	}

	if (xp->func != NULL)
		(*xp->func)(xp->chNo, xp->blkno);

	return(0);
}

/*=======================================================================
 |
 |		t@CM
 |
 |	SHORT	RXmodem(chNo, fp, func)
 |
 |		USHORT	chNo;		`lԍ
 |		FILE	*fp;		t@C|C^
 |		VOID	(*func)();	ubNԍ\֐
 |
 |		Ԓl			@OFI
 |					|PFMs
 |					|QF~
 |
 =======================================================================*/
SHORT	RXmodem(USHORT chNo, FILE *fp, VOID (*func)())
{
	SHORT	st, ev;
	DCBINFO		svDCBInfo, DCBInfo;
	XMODEM	xmodem;

	if (chNo == CH0)
		return(-1);

	xFlag[chNo] = TRUE;

	DosDevIOCtl(&DCBInfo, 0L, ASYNC_GETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);
	memcpy(&svDCBInfo, &DCBInfo, sizeof(DCBINFO));

	DCBInfo.fbFlowReplace = 0;
	DCBInfo.fbTimeout = MODE_READ_TIMEOUT;
	DosDevIOCtl(0L, &DCBInfo, ASYNC_SETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);

	ClearRcvQue(chNo);		/* Mobt@NA */

	xmodem.chNo = chNo;
	xmodem.fp  = fp;
	xmodem.func = func;

	st = r_start(&xmodem);		/* MJn */
	while (st > 0) {
		ev = event(&xmodem);	/* Cxg҂ */
		switch (st) {
		case ST_1:
			st = r_st1(&xmodem, ev);
			break;
		case ST_2:
			st = r_st2(&xmodem, ev);
			break;
		}
	}

	DosDevIOCtl(0L, &svDCBInfo, ASYNC_SETDCBINFO,
					IOCTL_ASYNC, portHndl[chNo]);

	xFlag[chNo] = FALSE;

	return(st);
}

/*=======================================================================
 |
 |		t@CMJn
 |
 |	SHORT	r_start(xp)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |
 |		Ԓl			rsQP
 |
 =======================================================================*/
static	SHORT	r_start(XMODEM *xp)
{
	SendChar(xp, NAK);		/* m`jiMvjM */
	SetTimer(xp, 10);		/* rng҂^C}[Zbg */
	xp->retry_counter = 0;		/* gCJE^NA */
	xp->blkno = 0;			/* ubNԍNA */
	return(ST_1);
}

/*=======================================================================
 |
 |		rngM҂
 |
 |	SHORT	r_st1(xp, ev)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	SHORT	r_st1(XMODEM *xp, SHORT ev)
{
	SHORT	st;

	st = ST_1;
	switch (ev) {
	case SOH:
		xp->rcv_buf[0] = SOH;	/* rngZ[u */
		xp->rcv_counter = 1;	/* MJE^Zbg */
		SetTimer(xp, 1);	/* ԃ^C}[Zbg */
		st = ST_2;
		break;
	case EOT:
		SendChar(xp, ACK);	/* `bjM */
		st = ST_END;
		break;
	case TIMEOUT:
		if (++xp->retry_counter <= 10) {	/* gC`FbN */
			SendChar(xp, NAK);	/* m`jM */
			SetTimer(xp, 10);	/* rng҂^C}[Zbg */
		} else {
			/* gCI[o */
			SendChar(xp, CAN);	/* b`mM */
			st = ST_ERR;
		}
		break;
	case ABORT:
		SendChar(xp, CAN);	/* b`mM */
		st = ST_ABORT;
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM҂
 |
 |	SHORT	r_st2(xp, ev)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	ev;		Cxg
 |
 |		Ԓl			Xe[^XirsQwwwj
 |
 =======================================================================*/
static	SHORT	r_st2(XMODEM *xp, SHORT ev)
{
	SHORT	st;

	st = ST_2;
	switch (ev) {
	case TIMEOUT:
		if (++xp->retry_counter <= 10) {	/* gC`FbN */
			SendChar(xp, NAK);	/* m`jM */
			SetTimer(xp, 10);	/* rng҂^C}[Zbg */
			st = ST_1;
		} else {
			SendChar(xp, CAN);	/* b`mM */
			st = ST_ERR;
		}
		break;
	case ABORT:
		SendChar(xp, CAN);		/* b`mM */
		st = ST_ABORT;
		break;
	default:
		if (ev <= 0xff) {
			/* Mf[^Z[u*/
			xp->rcv_buf[xp->rcv_counter++] = (CHAR)ev;
			if (xp->rcv_counter == 132) {
				/* PubNMI */
				if (rcv_dat(xp) == 0) {
					/* Mf[^͐ */
					SendChar(xp, ACK);
					SetTimer(xp, 10);
					xp->retry_counter = 0;
					st = ST_1;
				} else {
					/* Mf[^ɃG[L */
					if (++xp->retry_counter <= 10) {
						SendChar(xp, NAK);
						SetTimer(xp, 10);
						st = ST_1;
					} else {
						SendChar(xp, CAN);
						st = ST_ERR;
					}
				}
			} else
				SetTimer(xp, 1);	/* ϰ */
		}
		break;
	}

	return(st);
}

/*=======================================================================
 |
 |		f[^ubNM
 |
 |	SHORT	rcv_dat(xp)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |
 |		Ԓl			OFubN
 |					PFُubN
 |
 =======================================================================*/
static	SHORT	rcv_dat(XMODEM *xp)
{
	CHAR	sum;
	SHORT	i;

	/* ubNԍ`FbN */
	if (xp->rcv_buf[1] != (CHAR)~xp->rcv_buf[2])
		return(1);

	/* `FbNT`FbN */
	sum = 0;
	for (i = 0; i < 128; i++)
		sum += xp->rcv_buf[3+i];
	if (sum != xp->rcv_buf[131])
		return(1);

	/* ubNԍV[PX`FbN */
	if (xp->rcv_buf[1] == (CHAR)xp->blkno)
		;
	else if (xp->rcv_buf[1] == (CHAR)(xp->blkno + 1)) {
		fwrite(xp->rcv_buf + 3, 128, 1, xp->fp);
		xp->blkno++;
	} else
		return(1);

	if (xp->func != NULL)
		(*xp->func)(xp->chNo, xp->blkno);

	return(0);
}

/*=======================================================================
 |
 |		Cxg҂
 |
 |	SHORT	event(xp)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |
 |		Ԓl			Cxg
 |
 =======================================================================*/
static	SHORT	event(XMODEM *xp)
{
	CHAR	rcvChar;
	USHORT	numBytes;
	SHORT	ev;
	SHORT	timer;

	timer = xp->timer;
	for (;;) {
		if (xFlag[xp->chNo] == FALSE) {
			ev = ABORT;
			break;
		}

		DosRead(portHndl[xp->chNo], &rcvChar, 1, &numBytes);
		if (numBytes != 0) {
			ev = rcvChar;
			break;
		} else if (--timer == 0) {
			ev = TIMEOUT;
			break;
		}
	}

	return(ev);
}

/*=======================================================================
 |
 |		PM
 |
 |	VOID	SendChar(xp, ch)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		CHAR	ch;		M
 |
 =======================================================================*/
static	VOID	SendChar(XMODEM *xp, CHAR ch)
{
	USHORT	numBytes;

	DosWrite(portHndl[xp->chNo], &ch, 1, &numBytes);
}

/*=======================================================================
 |
 |		PubNM
 |
 |	VOID	SendBlock(xp, block, len)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		CHAR	*block;		ubNobt@
 |		USHORT	len;		ubN
 |
 =======================================================================*/
static	VOID	SendBlock(XMODEM *xp, CHAR *block, USHORT len)
{
	USHORT	numBytes;

	DosWrite(portHndl[xp->chNo], block, len, &numBytes);
}

/*=======================================================================
 |
 |		^C}[Zbg
 |
 |	VOID	SetTimer(xp, tm)
 |
 |		XMODEM	*xp;		wlncdlp[^
 |		SHORT	tm;		^C}[l
 |
 =======================================================================*/
static	VOID	SetTimer(XMODEM *xp, SHORT tm)
{
	xp->timer = tm;
}

/*=======================================================================
 |
 |		wlncdl~
 |
 |	VOID	AbortXmodem(chNo)
 |
 |		USHORT	chNo;		`lԍ
 |
 =======================================================================*/
VOID	AbortXmodem(USHORT chNo)
{
	xFlag[chNo] = FALSE;
}

/*=======================================================================
 |
 |		bqbvZ
 |
 |	USHORT	calcrc(ptr, count)
 |
 |		CHAR	*ptr;		f[^obt@
 |		USHORT	crc;		f[^
 |
 |		Ԓl	bqb
 |
 =======================================================================*/
static	USHORT	calcrc(CHAR *ptr, SHORT count)
{
	USHORT	crc, i;

	crc = 0;
	while (--count >= 0) {
		crc = crc ^ (USHORT)*ptr++ << 8;
		for (i = 0; i < 8; i++)
			if (crc & 0x8000)
				crc = crc << 1 ^ 0x1021;
			else
				crc = crc << 1;
	}
	return(crc);
}
